/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.sanskritlibrary.viewer;

import java.io.File;
import java.io.IOException;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.ServletOutputStream;
import org.sanskritlibrary.Regex;
import java.io.FileInputStream;
import java.util.Hashtable;
import javax.servlet.http.Cookie;

/**
 *
 * @author rbunker
 */
public class FileFilter implements Filter
{

    public static final Hashtable<String, String> contentTypes = new Hashtable<String, String>();
    // http://www.webmaster-toolkit.com/mime-types.shtml
    static
    {
        contentTypes.put("htm", "text/html; charset=UTF-8");
        contentTypes.put("html", "text/html; charset=UTF-8");
        contentTypes.put("pdf", "application/pdf");
        contentTypes.put("png", "image/png");
        contentTypes.put("jpg", "image/jpeg");
        contentTypes.put("jpeg", "image/jpeg");
        contentTypes.put("gif", "image/gif");
        contentTypes.put("js", "text/javascript; charset=UTF-8");
        contentTypes.put("css", "text/css; charset=UTF-8");
        contentTypes.put("xml", "text/xml; charset=UTF-8");
        contentTypes.put("rtf", "application/rtf");
        contentTypes.put("txt", "text/plain; charset=UTF-8");
    }
    private static final boolean debug = false;
    // The filter configuration object we are associated with.  If
    // this value is null, this filter instance is not currently
    // configured.
    private FilterConfig filterConfig = null;

    public FileFilter()
    {
    }

    public boolean loadFile(HttpServletResponse response, String filename) throws IOException
    {
        int extStart = filename.lastIndexOf('.');
        if (extStart != -1)
        {
            String ext = filename.substring(extStart + 1);
            String contentType = contentTypes.get(ext);
            response.setContentType(contentType);
        }
        File f = new File(filename);
        if (!f.exists()) {
            return false;
        } else {
            FileInputStream fis = new FileInputStream(filename);
            byte[] b = new byte[fis.available()];
            fis.read(b);
            fis.close();
            ServletOutputStream sos = response.getOutputStream();
            sos.write(b);
            sos.flush();
            sos.close();

            return true;
        }
    }


    public void doFilter(ServletRequest request, ServletResponse response,
            FilterChain chain)
            throws IOException, ServletException
    {
        HttpServletRequest httpRequest = (HttpServletRequest) request;
        HttpServletResponse httpResponse = (HttpServletResponse) response;

        String url = httpRequest.getServletPath();
        if (url.startsWith("/imageLines"))
        {
            loadFile(httpResponse, "/Users/ralph/Donglai/sanskrit_line/mscoll390_item349_wk1_body0002_crop1_line12.jpg");
        } else
            chain.doFilter(request, response);
        }

    /**
     * Return the filter configuration object for this filter.
     */
    public FilterConfig getFilterConfig()
    {
        return (this.filterConfig);
    }

    /**
     * Set the filter configuration object for this filter.
     *
     * @param filterConfig The filter configuration object
     */
    public void setFilterConfig(FilterConfig filterConfig)
    {
        this.filterConfig = filterConfig;
    }

    /**
     * Destroy method for this filter
     */
    public void destroy()
    {
    }

    /**
     * Init method for this filter
     */
    public void init(FilterConfig filterConfig)
    {
        this.filterConfig = filterConfig;
    }
}
