"use strict";    
//https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest
//http://stackoverflow.com/questions/2130452/how-to-efficiently-append-content-with-jquery
//http://jscrollpane.kelvinluck.com/
//http://jscrollpane.kelvinluck.com/settings.html
//http://jscrollpane.kelvinluck.com/api.html
var T = {};				// namespace
T.transcodersXML = {};
T.transcoders = {};
T.api;
T.blockSize = 8192;
T.currentTargetHighlighted = null;
T.prevMatchedLineText = null;
T.prevMatchedLineObj = null;
T.currentAnswer = -1;
T.answers = [];
T.transcodeBuffer = "";
T.currentTranscoder = null;
    

T.getXMLHttpRequest = function() {
    var xhp = null;
    if (window.XMLHttpRequest) {
        xhp = new window.XMLHttpRequest();
    }
    else {
        try {
            xhp = new ActiveXObject("MSXML2.XMLHTTP");
        }
        catch(ex) {
            alert(ex);
        }
    }
    return xhp;
}
    
T.init = function() {
    document.getElementById("query").onkeydown = function(event) { return getKeyStroke(event); };
    document.getElementById("query").onkeyup = function(event) { return transcode(event); }
    loadTranscoder("slp1_roman");
}


T.loadTranscoder = function(type) {
    var xhp, url, elText, blocks, parser, xmlDoc;
    if (!T.transcoders[type]) {
    	parser=new DOMParser();
    	xmlDoc=parser.parseFromString(T.transcodersXML[type], "text/xml");
    	T.transcoders[type] = T.convertXML(xmlDoc);
    	T.currentTranscoder = T.transcoders[type];
    }
}

T.displayText = function(blocks) {
    var len, i;
            
    len = blocks.length;
    for (i=0; i<len; i++) {
        api.getContentPane().append(blocks[i]);
    }
    api.reinitialise();
}

T.convertXML = function(xml) {
    var fsm, edges, edge, len, i, j, e, t, el, ctx, ch, list, h, s, cl, transcoder;
    
    transcoder = {};
    
    fsm = xml.getElementsByTagName("fsm")[0];
    
    el = fsm.attributes.getNamedItem("inputType");
    if (el) {
        transcoder.inputType = el.nodeValue;
    } else {
        transcoder.inputType = null;
    }
    
    el = fsm.attributes.getNamedItem("outputType");
    if (el) {
        transcoder.outputType = el.nodeValue;
    } else {
        transcoder.outputType = null;
    }
    
    el = fsm.attributes.getNamedItem("version");
    if (el) {
        transcoder.version = el.nodeValue;
    } else {
        transcoder.version = null;
    }    
    
    el = fsm.attributes.getNamedItem("capitalsSupported");
    if (el) {
        transcoder.capitalsSupported = el.nodeValue;
    } else {
        transcoder.capitalsSupported = null;
    }    

    edges = fsm.getElementsByTagName("edges")[0];
    edge = edges.getElementsByTagName("e");
    len = edge.length;
    transcoder.classes = {};
    transcoder.edges = [];
    transcoder.h = {};
    for (i=0; i<len; i++) {
        e = edge[i];
        t = {};
        transcoder.edges.push(t);
        
        t.n = e.attributes.getNamedItem("n").nodeValue;
        
        el = e.getElementsByTagName("in")[0];
        if (el) {
            t.in = T.convertUnicode(el.textContent);
            ch = t.in.charAt(0);
            list = transcoder.h[ch];
            
            if (list) {
                list.push(t);
            } else {
                transcoder.h[ch] = [t];
            }
        } else {
            t.in = null;
        }
        
        el = e.getElementsByTagName("out")[0];
        if (el) {
            t.out = T.convertUnicode(el.textContent);
        } else {
            t.out = null;
        }
        
        el = e.getElementsByTagName("cl")[0];
        if (el) {          
            t.cls = el.textContent;
            cl = t.cls.split(";");
            if (cl.length > 1) {
                j = 0;
            }
            for (j=0; j<cl.length; j++) {
                h = transcoder.classes[cl[j]];
                if (!h) {
                    h = {};
                    transcoder.classes[cl[j]] = h;
                }
                h[t.in] = true;; 
            }
        } else {
            t.cls = null;
        }
        
        ctx = e.getElementsByTagName("ctx")[0];
        if (ctx) {    
            transcoder.contextual = true;
            t.ctx ={};
            el = ctx.attributes.getNamedItem("card");
            if (el) {
                t.ctx.option = el.nodeValue;
            } else {
                t.ctx.option = "+";
            }
            
            el = ctx.attributes.getNamedItem("dir");
            if (el) {
                t.ctx.leftToRight = el.nodeValue.toLowerCase() === "after";
            } else {
                t.ctx.leftToRight = true;
            }

            el = ctx.attributes.getNamedItem("x");
            if (el) {
                t.ctx.exists = true;
                t.ctx.eolOverride = false;
                list = el.nodeValue.toLowerCase().split("|");
                for (j=0; j<list.length; j++) {
                    s = list[j];
                    if (s === "y") {
                        t.ctx.exists = true;
                    } else if (s === "n") {
                        t.ctx.exists = false;
                    } else if (s === "eol") {
                        t.ctx.eolOverride = true;
                    }
                }
            } else {
                t.ctx.exists = false;
            }
            
            t.ctx.category = ctx.textContent.substring(1);     // get rid of $    
        } else {
            transcoder.contextual = false;
            t.ctx = null;
        }
    }
    
    return transcoder;    
}

// convert unicode encoded text to raw text
T.convertUnicode = function(s) {
    return s.replace(
                  /\\u([0-9a-f]{4})/g, 
                  function (whole, group1) {
                      return String.fromCharCode(parseInt(group1, 16));
                  }
              );
}

T.transcodeText = function(lines, options, offset) {
    var len, i, ch, e, result, list, j, k, bestlen, bestidx, s, blocks, totalLength, line, numlines, lineno, buffer,
    generateParagraphs, firstline, lastline, transcoder;
        
    numlines = lines.length;

    if (options) {
    	generateParagraphs = options.generateParagraphs;
    	firstline = options.firstline;
    	lastline = options.lastline;
    	transcoder = options.transcoder;
	    if (transcoder === undefined) {
	    	transcoder = T.currentTranscoder;
    	}
    } else {
    	generateParagraphs = false;
    	transcoder = T.currentTranscoder;
    }
    
    totalLength = 0;
    buffer = [];
    blocks = [];
    if (firstline === undefined) {
        firstline = 0;
        lastline = numlines
    } else if (lastline === undefined){
        lastline = numlines;
    }
    
    
    for (lineno=firstline; lineno<lastline; lineno++) {
        line = lines[lineno];
        if (offset) {
        	line = line.substring(offset);
        }
        len = line.length;
        if (generateParagraphs) {
            result = "<p id='p" + lineno + "'>";
        } else {
            result = "";
        }
        for (i=0; i<len; i++) {
            ch = line.charAt(i);
            list = transcoder.h[ch];
            if (!list) {
                continue;
            }
            if (list.length === 1) {
                bestidx = 0;
            } else {
                bestlen = 0;
                bestidx = 0;
                for (j=0; j<list.length; j++) {
                    s = list[j].in;
                    k = s.length;
                    if (line.substr(i, k) === s) {
                            if (k > bestlen && T.contextCheck(transcoder, line, i, list[j])) {
                                bestlen = k;
                                bestidx = j;
                            }
                        }
                    }
                }
                result += list[bestidx].out;
            }

            buffer.push(generateParagraphs ? (result +"</p>") : result);
            totalLength += result.length;
            if (totalLength > T.blockSize) {
                blocks.push(buffer.join("\n"));
                buffer.length = 0;
                totalLength = 0;
                result = "";
            }
        }
        s = buffer.join("\n");
        if (s.length > 0) {
            blocks.push(s);
        } else if (blocks.length == 0) {
            blocks = [""];  // must have been passed the empty string
        }
        return blocks;
}

// check if text.substring(n) matches context (if any) 
T.contextCheck = function(transcoder, line, n, edge) {
    var found, idx, match, nextidx, currentidx, previdx, beforeidx;
    
    if (edge.n === "90") {
        edge.n = "90";
    }
    if (edge.ctx) {
        found = false;
        match = edge.in;
        idx = n + match.length;
        nextidx = idx;            // used by left to right
        currentidx = idx - match.length;       // used by right to left

        if (edge.ctx.leftToRight) { // look to the right                        
            previdx = nextidx;
            nextidx = T.searchEdgeCollectionRight(transcoder, edge.ctx, line, nextidx);
            found = T.checkStatus(edge.ctx, previdx, nextidx, nextidx === line.length);
        } else {// look to the left                        
            beforeidx = T.searchEdgeCollectionLeft(transcoder, edge.ctx, line, currentidx);
            found = T.checkStatus(edge.ctx, currentidx, beforeidx, beforeidx === 0);
        }
        if (!found) {
            match = "";
        } else {
            match = line.substring(n, idx);
        }
        
        return match;        
    }
}

    // move through line+idx until a character not in mi's edgeCollection is encountered.
T.searchEdgeCollectionRight = function(transcoder, ctx, line, idx) {
    var card, prefix;
    
        card = ctx.option;
        prefix = null;
        do {
            prefix = T.matchRight(ctx, transcoder.classes[ctx.category], line, idx);
            if (prefix !== null) {
                idx += prefix.length;
            }
            if (card === "1") {
                break;
            }
        } while (prefix !== null);

        return idx;
    }

T.searchEdgeCollectionLeft = function(transcoder, ctx, line, idx) {
        var card, prefix;
        
        card = ctx.option;
        prefix = null;
        do {
            prefix = T.matchLeft(ctx, transcoder.classes[ctx.category], line, idx);
            if (prefix !== null) {
                idx -= prefix.length;
            }
            if (card === "1") {
                break;
            }
        } while (prefix !== null);

        return idx;
    }

T.matchRight = function(ctx, classCollection, s, idx) {
        var len, key, obj;
        
        if (!ctx.maxEdgeLength) {
            T.computeMaxEdgeLength(ctx, classCollection);
        }
        // try longest edges first
        for (len = ctx.maxEdgeLength; len >= 1; len--) {
            if (idx + len > s.length) {   // len is too long, continue loop to get shorter length
                continue;
            }

            key = s.substring(idx, idx + len);
            if (classCollection[key] !== undefined) {
                return key;
            }
        }

        return null;
}

T.matchLeft = function(ctx, classCollection, s, idx) {
        var len, key;
        
        if (!ctx.maxEdgeLength) {
            T.computeMaxEdgeLength(ctx, classCollection);
        }
        // try longest edges first
        for (len = ctx.maxEdgeLength; len >= 1; len--) {
            if (idx - len < 0) // len is too short, continue loop to get a shorter length
            {
                continue;
            }
            key = s.substring(idx - len, idx);
            if (classCollection[key] !== undefined) {
                return key;
            }
        }

        return null;
}

T.computeMaxEdgeLength = function(ctx, classCollection) {            
        var propname;
        ctx.maxEdgeLength = 0;
        for (propname in classCollection) {
            if (classCollection.hasOwnProperty(propname)) {
                if (propname.length > ctx.maxEdgeLength) {
                    ctx.maxEdgeLength = propname.length;
                }
            } 
         }
}

T.checkStatus = function(ctx, previdx, idx, atend) {
        var rc = false;

        if (ctx.eolOverride && atend && previdx === idx) // if eol is OK and nothing was matched because we are at the end (or beginning) of the line this overrides everything else.
        {
            rc = true;
        } else if (idx !== previdx) // something was matched
        {
            rc = ctx.exists;
        } else // no match found
        {
            if (!ctx.exists) // if it is not supposed to exist then mark it found
            {
                rc = true;
            } else if (ctx.option.equals("*")) // if it is okay for it not to exist, then mark it found
            {
                rc = true;       // don't break, there may be another
            } else // something must exist, so fail
            {
                rc = false;
            }
        }

        return rc;
    }
    
T.search = function(lines) {
        var query, i, len, line, percent, s, text, el, pattern, currentTarget, currentTargetHighlighted;
        
        if (!lines) {
            return;
        }
        
        if (T.currentAnswer === -1) {
            //query = document.getElementById("query").value;
            query = T.transcodeBuffer;
            currentTarget = T.transcodeText(lines, [query], false);
            currentTargetHighlighted = "<span style='background-color:silver'>" + currentTarget + "</span>";
            T.answers.length = 0;
            len = lines.length;
            for (i=0; i<len; i++) {
                line = lines[i];
                if (line.indexOf(query) !== -1) {
                    T.answers.push(i);
                }
            }
            T.currentAnswer = 0;
        }
        if (T.currentAnswer != T.answers.length) {
            if (T.prevMatchedLineObj) {
                T.prevMatchedLineObj.innerHTML = T.prevMatchedLineText;
            }
            el = document.getElementById("p" + T.answers[T.currentAnswer++]);
            if (T.currentAnswer == T.answers.length) {
                T.currentAnswer = 0;
            }
            T.prevMatchedLineObj = el;
            text = el.innerHTML;
            T.prevMatchedLineText = text;
            pattern = new RegExp(currentTarget, "g");
            text = text.replace(pattern, currentTargetHighlighted);
            el.innerHTML = text;
            api.scrollToY(el.offsetTop);
        }
}
    
T.reset = function() {
        T.currentAnswer = -1;
}
    
T.getKeyStroke = function (evt) {
        var ch, keyCode;
        
        //document.getElementById("debug").innerHTML = "" + evt.keyCode;
        if (evt.keyCode == 8) {
            T.transcodeBuffer = T.transcodeBuffer.substr(0, T.transcodeBuffer.length-1);
        } else if (evt.keyCode !== 16) {
            keyCode = evt.keyCode;            
            if (!evt.shiftKey) {
                keyCode += 32;          // make lower case
            }
            T.transcodeBuffer += String.fromCharCode(keyCode);
        }
    }
    
T.transcode = function (evt) {
        var s, obj;
        
        obj = document.getElementById("query")
        s = T.transcodeText([T.transcodeBuffer], {generateParagraphs:false});
        obj.value = s[0];
    }

    
$(function()
{
/*
    var settings = {
        showArrows: true
    };
    var pane = $('.scroll-pane');
    pane.jScrollPane(settings);
    api = pane.data('jsp');
    var i = 1;


    // Every second add some new content...
    
    timer = setInterval(
        function() {
            api.getContentPane().append(
                $('<p />').text('This is paragraph number ' + i++)
            );
            // we could call "pane.jScrollPane(settings)" again but it is
            // more convenient to call via the API as then the original
            // settings we passed in are automatically remembered.
            api.reinitialise();
            count++;
"use strict";    
//https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest
//http://stackoverflow.com/questions/2130452/how-to-efficiently-append-content-with-jquery
//http://jscrollpane.kelvinluck.com/
//http://jscrollpane.kelvinluck.com/settings.html
//http://jscrollpane.kelvinluck.com/api.html
var transcoder = {};
var timer = null;
var currentBlock = 0;
var api;
var blockSize = 8192;
var lineHeight = 0;
var lines;
var currentTarget = null;
var currentTargetHighlighted = null;
var prevMatchedLineText = null;
var prevMatchedLineObj = null;
var currentAnswer = -1;
var answers = [];

$(function()
{
/*
    var settings = {
        showArrows: true
    };
    var pane = $('.scroll-pane');
    pane.jScrollPane(settings);
    api = pane.data('jsp');
    var i = 1;


    // Every second add some new content...
    
    timer = setInterval(
        function() {
            api.getContentPane().append(
                $('<p />').text('This is paragraph number ' + i++)
            );
            // we could call "pane.jScrollPane(settings)" again but it is
            // more convenient to call via the API as then the original
            // settings we passed in are automatically remembered.
            api.reinitialise();
            count++;
"use strict";    
//https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest
//http://stackoverflow.com/questions/2130452/how-to-efficiently-append-content-with-jquery
//http://jscrollpane.kelvinluck.com/
//http://jscrollpane.kelvinluck.com/settings.html
//http://jscrollpane.kelvinluck.com/api.html
var transcoder = {};
var timer = null;
var currentBlock = 0;
var api;
var blockSize = 8192;
var lineHeight = 0;
var lines;
var currentTarget = null;
var currentTargetHighlighted = null;
var prevMatchedLineText = null;
var prevMatchedLineObj = null;
var currentAnswer = -1;
var answers = [];

$(function()
{
/*
    var settings = {
        showArrows: true
    };
    var pane = $('.scroll-pane');
    pane.jScrollPane(settings);
    api = pane.data('jsp');
    var i = 1;


    // Every second add some new content...
    
    timer = setInterval(
        function() {
            api.getContentPane().append(
                $('<p />').text('This is paragraph number ' + i++)
            );
            // we could call "pane.jScrollPane(settings)" again but it is
            // more convenient to call via the API as then the original
            // settings we passed in are automatically remembered.
            api.reinitialise();
            count++;
            if (count == 20) {
                clearInterval(timer);
                timer = null;
            }
	},
	1000
    );
  */
});
